javax.persistence

## Annotation Type NamedStoredProcedureQuery

    @Repeatable(value=NamedStoredProcedureQueries.class)
     @Target(value=TYPE)
     @Retention(value=RUNTIME)
    public @interface NamedStoredProcedureQuery

Specifies and names a stored procedure, its parameters, and its result type.

The `NamedStoredProcedureQuery` annotation can be applied to an entity or mapped superclass.

The `name` element is the name that is passed as an argument to the `EntityManager.createNamedStoredProcedureQuery(java.lang.String)` method to create an executable `StoredProcedureQuery` object. Names are scoped to the persistence unit.

The `procedureName` element is the name of the stored procedure in the database.

The parameters of the stored procedure are specified by the `parameters` element. All parameters must be specified in the order in which they occur in the parameter list of the stored procedure.

The `resultClasses` element refers to the class (or classes) that are used to map the results. The `resultSetMappings` element names one or more result set mappings, as defined by the `SqlResultSetMapping` annotation.

If there are multiple result sets, it is assumed that they will be mapped using the same mechanism — e.g., either all via a set of result class mappings or all via a set of result set mappings. The order of the specification of these mappings must be the same as the order in which the result sets will be returned by the stored procedure invocation. If the stored procedure returns one or more result sets and no `resultClasses` or `resultSetMappings` element is specified, any result set will be returned as a list of type Object[]. The combining of different strategies for the mapping of stored procedure result sets is undefined.

The `hints` element may be used to specify query properties and hints. Properties defined by this specification must be observed by the provider. Vendor-specific hints that are not recognized by a provider must be ignored.

All parameters of a named stored procedure query must be specified using the `StoredProcedureParameter` annotation.

See Also:
  `StoredProcedureQuery`, `StoredProcedureParameter`
Since:
  Java Persistence 2.1

### Required Element Summary

Required Elements
`java.lang.String` `name` The name used to refer to the query with the `EntityManager` methods that create stored procedure query objects.
`java.lang.String` `procedureName` The name of the stored procedure in the database.

### Optional Element Summary

Optional Elements
`QueryHint[]` `hints` Query properties and hints.
`StoredProcedureParameter[]` `parameters` Information about all parameters of the stored procedure.
`java.lang.Class[]` `resultClasses` The class or classes that are used to map the results.
`java.lang.String[]` `resultSetMappings` The names of one or more result set mappings, as defined in metadata.

### Element Detail

#### name

    public abstract java.lang.String name

The name used to refer to the query with the `EntityManager` methods that create stored procedure query objects.

#### procedureName

    public abstract java.lang.String procedureName

The name of the stored procedure in the database.

#### parameters

    public abstract StoredProcedureParameter[] parameters

Information about all parameters of the stored procedure. All parameters must be specified in the order in which they occur in the parameter list of the stored procedure.

Default:
  {}

#### resultClasses

    public abstract java.lang.Class[] resultClasses

The class or classes that are used to map the results.

Default:
  {}

#### resultSetMappings

    public abstract java.lang.String[] resultSetMappings

The names of one or more result set mappings, as defined in metadata.

Default:
  {}

#### hints

    public abstract QueryHint[] hints

Query properties and hints. (May include vendor-specific query hints.)

Default:
  {}